package	jp.co.sds_corp.tool.bean;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.Reader;
import java.text.ParseException;
import java.util.Vector;

import jp.co.sds_corp.util.common.CmnString;

public class BeanCreator
{
	class BeanInfo
	{
		String name;
		String type;
		String desc;
		String func;

		BeanInfo( String name ) throws ParseException {
			this.name = name;
			this.type = "String";
			getFunc();
			this.desc = this.name;
		}
		BeanInfo( String name, String type ) throws ParseException {
			this.name = name;
			if ( type != null && type.length() > 0 ) {
				this.type = type;
			} else {
				this.type = "String";
			}
			getFunc();
			this.desc = this.name;
		}
		BeanInfo( String name, String type, String desc ) throws ParseException {
			this.name = name;
			if ( type.length() > 0 ) {
				this.type = type;
			} else {
				this.type = "String";
			}
			this.desc = desc;
			getFunc();
		}
		void getFunc() throws ParseException {
			int idx;
			idx = name.indexOf( " = new Vector" );
			if ( idx >= 0 ) {
				name = name.substring( 0, idx );
			}
			idx = name.indexOf( " = new HashMap" );
			if ( idx >= 0 ) {
				name = name.substring( 0, idx );
			}
			idx = name.indexOf( " = new TreeMap" );
			if ( idx >= 0 ) {
				name = name.substring( 0, idx );
			}
			if ( name.indexOf( " " ) >= 0 ) {
				throw( new ParseException( "name includes SPACE.", 0 ));
			}
			if ( name.endsWith( ";" )) {
				name = name.substring( 0, name.length() - 1 );
			}
			if ( desc != null && desc.startsWith( "// " )) {
				desc = desc.substring( 3 );
			}
			if ( desc != null && desc.startsWith( "//" )) {
				desc = desc.substring( 2 );
			}
			StringBuffer buf = new StringBuffer( name );
			char upper = Character.toUpperCase( buf.charAt( 0 ));
			buf.setCharAt( 0, upper );
			func = buf.toString();
		}

		void printVar( PrintWriter out ) {
			if ( type.startsWith( "Vector" ) ||
				type.startsWith( "HashMap" ) ||
				type.startsWith( "TreeMap" ))
			{
				out.print( "\t" + type + "\t" + name + " = new " + type +"();");
			} else {
				out.print( "\t" + type + "\t" + name + ";" );
			}
			if ( desc != null && desc.length() > 0 ) {
				out.println( "\t// " + desc );
			} else {
				out.println( "" );
			}
		}
		void printBean( PrintWriter out ) {
			out.println( "\t/**" );
			if ( bVar ) {
				out.println( "\t* " + desc + "(" + name + ")を設定します。" );
			} else {
				if ( desc == null ) {
					out.println( "\t* " + name + "を設定します。" );
				} else {
					out.println( "\t* " + desc + "を設定します。" );
				}
			}
			out.println( "\t* @param\tvar\t\t設定するデータ" );
/*
			out.println( "\t* @return\tなし" );
*/
			out.println( "\t*/" );
			out.println( "\tpublic void set" + func + "( " + type + " var ) {" );
			out.println( "\t\tthis." + name + " = var;" );
			out.println( "\t}" );
			out.println( "\t/**" );
			if ( bVar ) {
				out.println( "\t* " + desc + "(" + name + ")を取得します。" );
			} else {
				if ( desc == null ) {
					out.println( "\t* " + name + "を取得します。" );
				} else {
					out.println( "\t* " + desc + "を取得します。" );
				}
			}
			if ( bVar ) {
				out.println( "\t* @return\t" + name + "の内容" );
			} else {
				if ( desc == null ) {
					out.println( "\t* @return\t" + name + "の内容" );
				} else {
					out.println( "\t* @return\t" + desc );
				}
			}
			out.println( "\t*/" );
			if ( type.equals( "boolean" )) {
				out.println( "\tpublic " + type + " is" + func + "() {" );
			} else {
				out.println( "\tpublic " + type + " get" + func + "() {" );
			}
			out.println( "\t\treturn " + name + ";" );
			out.println( "\t}" );
			out.println( "" );
		}
	}

	String	file;
	Vector<BeanInfo>	vecBean = new Vector<BeanInfo>();
	boolean	bVar = true;
	String	encode;

	public BeanCreator( String file ) {
		this.file = file;
		String	var;
		var = System.getProperty( "bean.printvar" );
		if ( var != null && var.equals( "false" )) {
			bVar = false;
		}
		encode = System.getProperty( "bean.encode" );
	}

	protected void printVar( PrintWriter out, Vector<BeanInfo> vecBean ) {
		for ( int i = 0; i < vecBean.size(); i++ ) {
			BeanInfo bean = (BeanInfo )vecBean.get( i );
			bean.printVar( out );
		}
		out.println( "" );
	}
	protected void printBean( PrintWriter out, Vector<BeanInfo> vecBean ) {
		for ( int i = 0; i < vecBean.size(); i++ ) {
			BeanInfo bean = (BeanInfo )vecBean.get( i );
			bean.printBean( out );
		}
		out.println( "" );
	}
	public void convert() throws Exception {
		int		nPos = file.indexOf( "." );
		if ( nPos < 0 ) {
			nPos = file.length();
		}

		Reader rd;
		if ( encode == null ) {
			rd = new InputStreamReader( new FileInputStream( file ) );
		} else {
			rd = new InputStreamReader( new FileInputStream( file ), encode );
		}
		BufferedReader br = new BufferedReader( rd );
/*
		String out_file = file.substring( 0, nPos ) + ".java";
		PrintWriter out = new PrintWriter(
							new OutputStreamWriter(
							new FileOutputStream( out_file ) ));
*/
		PrintWriter out = new PrintWriter( System.out );
		int     nLine = 0;
		String  line;
		for ( ;; ) {
			line = br.readLine();
			if ( line == null ) {
				break;
			}
			nLine++;
			// 空行は読み飛ばし
			if ( line.length() == 0 ) {
				continue;
			}
			BeanInfo bean = null;
			try {
				bean = convertLine( line );
			} catch ( Exception ex ) {
				System.err.println( ex.toString() );
			}
			if ( bean == null ) {
				System.err.println( "ignore line(" + nLine + ") [" + line + "]" );
			} else {
				vecBean.add( bean );
			}
		}

		printVar( out, vecBean );
		printBean( out, vecBean );

		out.flush();
		out.close();
		br.close();
	}

	protected BeanInfo convertLine( String line ) throws Exception {
		String[] buf = CmnString.getStringToken( line, "\t", true );
		BeanInfo bean = null;
		switch ( buf.length ) {
		case 1:
		case 2: bean = new BeanInfo( buf[0] ); break;
		case 3: bean = new BeanInfo( buf[0], buf[2] ); break;
		case 4: bean = new BeanInfo( buf[0], "", buf[3] ); break;
		case 5: bean = new BeanInfo( buf[0], buf[2], buf[4] ); break;
		default:
			break;
		}
		return bean;
	}

	public static void main( String[] args ) {
		for ( int i = 0; i < args.length; i++ ) {
			try {
				BeanCreator	obj = new BeanCreator( args[i] );
				obj.convert();
			} catch ( Exception e ) {
				e.printStackTrace();
			}
		}
	}
}
